Bug 13278 - Apache init script graceful restarts, proper exit values
Apache init script graceful restarts, proper exit values
Product: Red Hat Linux
Classification: Retired
Component: apache (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nalin Dahyabhai
: FutureFeature
: 49235 (view as bug list)
Depends On:
  Show dependency treegraph
Reported: 2000-06-30 12:59 EDT by sumnerh
Modified: 2008-05-01 11:37 EDT (History)
0 users

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2001-09-04 19:16:17 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description sumnerh 2000-06-30 12:59:28 EDT
Apache's init script needs a small addition to allow it to perform graceful
restarts--graceful restarts do zero-downtime updates of loaded modules and
configuration file alterations.  This is very handy for people using Apache
on mission-critical servers.

The URL I listed explains exactly what how graceful restarts work.

Here's what I added to the /etc/rc.d/init.d/httpd init script:

        echo -n "Hot starting httpd: "
        killproc httpd -USR1

"graceful" might be a better name for the target than "hotstart".  Also, it
would make a lot of sense to store the killproc return value and exit from
the init script with that return value.  That would turn the above into:

        echo -n "Gracefully restarting httpd: "
        killproc httpd -USR1
        exit $RV

And the default line ("Usage: $0 {.....}") should probably mention the
graceful/hotstart option.

E-mail me if you have any questions: SumnerH at fool.com
Comment 1 Nalin Dahyabhai 2000-06-30 18:55:08 EDT
This should be incorporated into apache-1.3.12-10, which will hit Raw Hide soon.
Comment 2 Matthew Miller 2001-09-04 19:13:29 EDT
actually, this isn't in the very latest rawhide (apache-1.3.20-15). Looks from
the comments like it was added at one point, but now it's gone again.
Comment 3 Matthew Miller 2001-09-04 19:14:13 EDT
*** Bug 49235 has been marked as a duplicate of this bug. ***
Comment 4 Matthew Miller 2001-09-04 19:16:13 EDT
The apachectl script that comes with apache also has a "configtest" option,
which would be nice.
Comment 5 Joe Orton 2002-05-27 07:56:30 EDT
The apache packages do now support "service httpd configtest".

Note You need to log in before you can comment on or make changes to this bug.